function vexpower_global_testmode()
	if vexpower.testmode then
		vexpower_energyTextbar:Hide()
		vexpower_CPsTextbar:Hide()
	else
		vexpower_energyTextbar:Show()
		vexpower_CPsTextbar:Show()
	end
	vexpower_test_starter()
	vexpower_panelText_testmode()
	vexpower_movable(vexpower.testmode)
end

function vexpower_testmodeDelayedStart()
	local frame = vexpower_MainFrame
	local test_aniGRP = frame:CreateAnimationGroup("test_aniGRP")
	test_aniGRP:SetLooping("NONE")
	local test_ani = test_aniGRP:CreateAnimation("Scale")
	test_ani:SetOrder(1)
	test_ani:SetDuration(0)
	test_ani:SetScale(1,1)
	test_ani:SetEndDelay(1)
	test_aniGRP:SetScript("OnFinished", function () vexpower.testmode = true vexpower_test_func() vexpower_test_starter() end)
	test_aniGRP:Play()
end

-- =======================
-- =====POWERBAR AND CPs==
-- =======================

function vexpower_test_starter()
	if vexpower.testmode then
		local frame = vexpower_MainFrame
		local test_aniGRP = frame:CreateAnimationGroup("test_aniGRP")
		test_aniGRP:SetLooping("NONE")
		local test_ani = test_aniGRP:CreateAnimation("Scale")
		test_ani:SetOrder(1)
		test_ani:SetDuration(0)
		test_ani:SetScale(1,1)
		test_ani:SetEndDelay(0.1)
		test_aniGRP:SetScript("OnFinished", function () vexpower_test_func() vexpower_test_starter() end)
		test_aniGRP:Play()
	end
end

function vexpower_test_func()
	if vexpower.testmode then
		if vexpower_test_func_changeEnergy() then
			vexpower_test_func_changeCP()
			vexpower_test_func_changeAltPower()
		end
		vexpower_changeText()
	end
end

function vexpower_test_func_changeCP()
	if vexpower.maxcps>0 then
		if not(vexpower.AltPower.created) then
			if vexpower.currentcps >= vexpower.maxcps then
				vexpower_changeCps(-vexpower.maxcps)
			else
				vexpower_changeCps(1)
			end
		end
	end
end

function vexpower_test_func_changeAltPower()
	if vexpower.maxcps>0 then
		if vexpower.AltPower.created then
			local gain = 0
			local loss = 0
			if vexpower.class == "WARLOCK" and vexpower.specType == 266 then
				gain = 50
				loss = -250
			elseif vexpower.class == "WARLOCK" and vexpower.specType == 267 then
				gain = 1
				loss = -10
			end
			for i in ipairs(vexpower.AltPower.Bar) do
				if vexpower.AltPower.currentenergy[i] == vexpower.AltPower.maxenergy[i] then
					vexpower_changeAltPower(i, loss)
				elseif vexpower.AltPower.currentenergy[i]+gain > vexpower.AltPower.maxenergy[i] then
					vexpower_changeAltPower(i, vexpower.AltPower.maxenergy[i]-vexpower.AltPower.currentenergy[i])
				else
					vexpower_changeAltPower(i, gain)
				end
			end
		end
	end
end

function vexpower_test_func_changeEnergy()
	local energychange = 0	
	local gained = false
	local gain = math.floor(vexpower.maxenergy/50)
	local loss = math.floor(-(4*vexpower.maxenergy)/10)
	
	if vexpower.currentenergy == vexpower.maxenergy then
		vexpower_changeEnergy(false, loss)
	elseif vexpower.currentenergy+gain > vexpower.maxenergy then
		vexpower_changeEnergy(false, vexpower.maxenergy-vexpower.currentenergy)
		gained = true
	else
		vexpower_changeEnergy(false, gain)
		gained = true
	end
	
	return not(gained)
end





-- =======================
-- =====TEXT==============
-- =======================
function vexpower_panelText_testmode()
	vexpower_panelText_testmodeNuke()
	
	if vexpower.testmode then
		vexpower_panelText_testmodeGenerate()
	end
end

function vexpower_panelText_testmodeGenerate()
	for key in pairs(vexpower_parameters["frame"]["energy"]["text"]) do
		if vexpower_parameters["frame"]["energy"]["text"][key] ~= nil then
			if vexpower_energytext_TestFrames == nil then
				vexpower_energytext_TestFrames = {}
			end
			if vexpower_energytext_TestFramesText == nil then
				vexpower_energytext_TestFramesText = {}
			end
			
			--Frame
			vexpower_energytext_TestFrames[key] = CreateFrame("Frame", nil, vexpower_energybarbg)
			vexpower_energytext_TestFrames[key]:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
			local bg = {math.random(), math.random(), math.random()}
			local border = {bg[1] + 0.5, bg[2] + 0.5, bg[3] + 0.5}
			if border[1] > 1 then border[1] = border[1] - 1 end
			if border[2] > 1 then border[2] = border[2] - 1 end
			if border[3] > 1 then border[3] = border[3] - 1 end
			vexpower_energytext_TestFrames[key]:SetBackdropColor(bg[1], bg[2], bg[3], 1)
			vexpower_energytext_TestFrames[key]:SetBackdropBorderColor(border[1], border[2], border[3], 1)
			vexpower_energytext_TestFrames[key]:SetWidth(vexpower_parameters["frame"]["energy"]["text"][key]["width"])
			vexpower_energytext_TestFrames[key]:SetHeight(vexpower_parameters["frame"]["energy"]["text"][key]["size"])
			vexpower_energytext_TestFrames[key]:SetFrameStrata("HIGH")
			vexpower_energytext_TestFrames[key]:ClearAllPoints()
			vexpower_energytext_TestFrames[key]:SetPoint(
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor"],
				"vexpower_energyTextbar",
				vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"],
				vexpower_parameters["frame"]["energy"]["text"][key]["x"],
				vexpower_parameters["frame"]["energy"]["text"][key]["y"])
			
			vexpower_energytext_TestFrames[key]:RegisterForDrag("LeftButton")
			vexpower_energytext_TestFrames[key]:SetScript("OnDragStart", function ()
				vexpower_energytext_TestFrames[key]:StartMoving()
				end)
			vexpower_energytext_TestFrames[key]:SetScript("OnDragStop", function (self)
				self:StopMovingOrSizing()
				local x1, y1 = self:GetLeft(), self:GetTop()
				local x2, y2 = self:GetParent():GetLeft(), self:GetParent():GetTop()
				self:ClearAllPoints()
				self:SetPoint("TOPLEFT", self:GetParent(), "TOPLEFT", x1 - x2, y1 - y2)
				vexpower_saveTextfieldPos(key)
				vexpower_setFontStrings()
				end)
			vexpower_energytext_TestFrames[key]:EnableMouse(true)
			vexpower_energytext_TestFrames[key]:SetMovable(true)
			
			
			--FontString
			vexpower_energytext_TestFramesText[key] = vexpower_energytext_TestFrames[key]:CreateFontString("vexpower_energytext_TestFramesText["..key.."]", "OVERLAY", "GameFontNormal")
			vexpower_energytext_TestFramesText[key]:Show()
			vexpower_energytext_TestFramesText[key]:ClearAllPoints()
			vexpower_energytext_TestFramesText[key]:SetPoint("CENTER", vexpower_energytext_TestFrames[key], "CENTER", 0, 0)
			vexpower_energytext_TestFramesText[key]:SetTextColor(vexpower_parameters["frame"]["energy"]["text"][key]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["text"][key]["color"]["a"])
			vexpower_energytext_TestFramesText[key]:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"][key]["font"]),
											vexpower_parameters["frame"]["energy"]["text"][key]["size"],
											vexpower_parameters["frame"]["energy"]["text"][key]["effect"])	
			vexpower_energytext_TestFramesText[key]:SetWidth(vexpower_parameters["frame"]["energy"]["text"][key]["width"])	
			vexpower_energytext_TestFramesText[key]:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"][key]["align"])
			if vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["allow"] then	
				vexpower_energytext_TestFramesText[key]:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["color"]["a"])
				vexpower_energytext_TestFramesText[key]:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["offset"]["x"],
													vexpower_parameters["frame"]["energy"]["text"][key]["shadow"]["offset"]["y"])
			else
				vexpower_energytext_TestFramesText[key]:SetShadowColor(0, 0, 0, 0)
				vexpower_energytext_TestFramesText[key]:SetShadowOffset(0, 0)
			end
			vexpower_energytext_TestFramesText[key]:SetText(vexpower_parseTagInfo(vexpower_parameters["frame"]["energy"]["text"][key]["text"]))
		end
	end
end

function vexpower_panelText_testmodeNuke()
	if vexpower_energytext_TestFrames~= nil then
		for key in pairs(vexpower_energytext_TestFrames) do
			if vexpower_energytext_TestFrames[key]~= nil then
				vexpower_energytext_TestFrames[key]:Hide()
				vexpower_energytext_TestFrames[key] = nil
			end
		end
	end
end

function vexpower_saveTextfieldPos(key)
	vexpower_parameters["frame"]["energy"]["text"][key]["anchor"] =  select(1, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["anchor2"] =  select(3, vexpower_energytext_TestFrames[key]:GetPoint())
	vexpower_parameters["frame"]["energy"]["text"][key]["x"] =  select(4, vexpower_energytext_TestFrames[key]:GetPoint())-vexpower_parameters["frame"]["energy"]["border"]["size"]
	vexpower_parameters["frame"]["energy"]["text"][key]["y"] =  select(5, vexpower_energytext_TestFrames[key]:GetPoint())+vexpower_parameters["frame"]["energy"]["border"]["size"]
end